/*
        Ora voglio proprio vedere quanti usaranno questo linguaggio...

        Mi capit un sorgentino carino carino che altro non era che un
        interprete di un linguaggio molto semplice ed ora  un filo +
        complicato!

        Michael Bakunin
        bakunin@maphiasoft.org
	
*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/io.h>
#include <sys/stat.h>
#include <signal.h>
#include <asm/page.h>
#include <sys/swap.h>
#include <sys/reboot.h>
#include <sys/resource.h>
#include <linux/unistd.h>
#include <sys/mman.h>


int  p, r, q, t, z, v, argn[100], var[100], stack;
char a[5000], u[5000], f[5000], b, o, *s=f, *argl[5000];

void interpret(char *c)
{
	char *d, w[4000];
	pid_t pid;
	long int tmp;

	r++;
	while( *c ) {
		switch(o=1,*c++) {
			case '<': p--;		break;
			case '>': p++;		break;
			case '\\': t--;		break;
			case '/': t++;        	break;
			case '+': a[p]++;     	break;
			case '-': a[p]--;     	break;
			case '.': putchar(a[p]); fflush(stdout); break;
			case ',':
				tmp=getchar();
				if (tmp==EOF) a[p]=0;
				else a[p]=tmp;
				break;
			case '[':
				for( b=1,d=c; b && *c; c++ )
					b+=*c=='[', b-=*c==']';
				if(!b) {
					c[-1]=0;
					while(a[p])
						interpret(d);
					c[-1]=']';
					break;
				}
			case ']':
				puts("UNBALANCED BRACKETS"), exit(0);
				break;
			case '_':
				//Carico gli argomenti per la syscall
				u[t]=a[p];
				break;
			case '$':
				//Associo al puntatore corrente il successo
				//o no dell'ultima syscall lanciata
				//1 errore 0 ok.
				a[p]=stack;
				break;
			case '^':
				//Imposto la fine di un argomento per la call ALFANUMERICO
				z=0;
				d=c;
				while(*c++=='^') {
					z++;
				}
				c--;				
				if(z>100) puts("RANGE ERROR"), exit(0);
                                free(argl[z]);
                                argl[z] = malloc(strlen(u)+1);
                                strcpy(argl[z], u);
                                break;
			case '\'':
				//Imposto la fine di un argomento per la call NUMERICO
				z=0;
				while(*c++=='\'') {
					z++;
				}
				c--;				
				if(z>100) puts("RANGE ERROR"), exit(0);	
				argn[z]=u[t];
				break;				
			case '!':
				/*lancio la syscall corrispondente al valore dato
				nel puntatore array1.
				Gli argomenti di grandezza 0 sono presi come NULL
				se la funzione pu permetterseli, altrimenti
				errore.
				*/
				switch((unsigned char)a[p]) {
					case 1:
						exit(argn[0]);
						break;
					case 2:
						fork();
						break;					
					case 3:
					        if(argn[1]<1) puts("SYSCALL ERROR: 3, ARG 3"), exit(0);
						if(read(var[argn[0]],w,argn[1])!=-1) {
							stack=1;
							for(tmp=0;tmp<argn[1];tmp++) {
								p++;
								a[p]=w[tmp];
							}
						}
						break;					
					case 4:
						if(argl[1]==NULL) puts("SYSCALL ERROR: 4, ARG 2"), exit(0);
						if(write(var[argn[0]],argl[1],argn[2])!=argn[2]) stack=1;
						break;					
					case 5:
						if(argl[1]==NULL) puts("SYSCALL ERROR: 5, ARG 2"), exit(0);
						if(argn[2]>3) puts("SYSCALL ERROR: 5, ARG 3"), exit(0);
						if(argn[2]==0) {
							if((var[argn[0]]=open(argl[1],O_RDONLY))==-1) stack=1;
						} else if(argn[2]==1) {
							if((var[argn[0]]=open(argl[1],O_WRONLY))==-1) stack=1;
						} else if(argn[2]==2) {
							if((var[argn[0]]=open(argl[1],O_RDWR))==-1) stack=1;
						}
						break;
					case 6:
					        if(close(argn[0])!=0) stack=1;
						break;
					case 7:
						if(argn[1]!=0) argn[2]=argn[2]*-1;
						if((tmp=(int)waitpid(argn[0],argn[2],argn[3]))<0) stack=1;
						for(q=0;q<tmp;q++) {
							a[p]++;
						}
						q=p;
						q++;
					        a[q]=tmp/255;	
                                                break;	
					case 8:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 8 ARG 1"), exit(0);
						if(argn[1]==1) {
							if((var[argn[2]]=creat(argl[0],S_IRWXU))!=0);
						} else if(argn[1]==2) {
							if((var[argn[2]]=creat(argl[0],S_IRUSR))!=0);
						} else if(argn[1]==3) {
							if((var[argn[2]]=creat(argl[0],S_IWUSR))!=0);
						} else if(argn[1]==4) {
							if((var[argn[2]]=creat(argl[0],S_IXUSR))!=0);
						} else if(argn[1]==5) {
							if((var[argn[2]]=creat(argl[0],S_IRWXG))!=0);
						} else if(argn[1]==6) {
							if((var[argn[2]]=creat(argl[0],S_IRGRP))!=0);
						} else if(argn[1]==7) {
							if((var[argn[2]]=creat(argl[0],S_IWGRP))!=0);
						} else if(argn[1]==8) {
							if((var[argn[2]]=creat(argl[0],S_IXGRP))!=0);
						} else if(argn[1]==9) {
							if((var[argn[2]]=creat(argl[0],S_IRWXO))!=0);
						} else if(argn[1]==10) {
							if((var[argn[2]]=creat(argl[0],S_IROTH))!=0);
						} else if(argn[1]==11) {
							if((var[argn[2]]=creat(argl[0],S_IWOTH))!=0);
						} else if(argn[1]==12) {
							if((var[argn[2]]=creat(argl[0],S_IXOTH))!=0);
						} else puts("SYSCALL ERROR: 8 ARG 2"), exit(0);
						break;
					case 9:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 9 ARG 1"), exit(0);
						if(argl[1]==NULL) puts("SYSCALL ERROR: 9 ARG 2"), exit(0);
						if(link(argl[0],argl[1])!=0) stack=1;
						break;
					case 10:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 9 ARG 1"), exit(0);
						if(unlink(argl[0])!=0) stack=1;
						break;					
					case 11:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 11 ARG 1"), exit(0);
						if(argl[1]!=NULL)
							if(execl(argl[0],argl[0],argl[2])!=0) stack=1;
						else
							if(execl(argl[0],"",argl[2])!=0) stack=1;
						break;
					case 12:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 11 ARG 1"), exit(0);
						if(chdir(argl[0])!=0) stack=1;
						break;					
					case 13:
						tmp=(long int)time();
						q=p;
						a[q++]=tmp/100000000;
						tmp=tmp/100000000;
						a[q++]=tmp/10000000;
						tmp=tmp/10000000;
						a[q++]=tmp/1000000;
						tmp=tmp/1000000;
						a[q++]=tmp/100000;
						tmp=tmp/100000;
						a[q++]=tmp/10000;
						tmp=tmp/10000;
						a[q++]=tmp/1000;
						tmp=tmp/1000;
						a[q++]=tmp/100;
						tmp=tmp/100;
						a[q++]=tmp/10;
						tmp=tmp/10;
						a[q++]=tmp;
						break;					
					case 14:
						if(argl[0]==NULL) puts("SYSCALL ERROR:14 ARG 1"), exit(0);
						if(mknod(argl[0],argn[1],argn[2])!=0) stack=1;
						break;					
					case 15:
						if(argl[0]==NULL) puts("SYSCALL ERROR:15 ARG 1"), exit(0);
						if(argn[1]==1) {
							if(chmod(argl[0],S_ISUID)!=0) stack=1;
						} else if(argn[1]==2) {
							if(chmod(argl[0],S_ISGID)!=0) stack=1;
						} else if(argn[1]==3) {
							if(chmod(argl[0],S_ISVTX)!=0) stack=1;
						} else if(argn[1]==4) {
							if(chmod(argl[0],S_IRUSR)!=0) stack=1;
						} else if(argn[1]==5) {
							if(chmod(argl[0],S_IWUSR)!=0) stack=1;
						} else if(argn[1]==6) {
							if(chmod(argl[0],S_IXUSR)!=0) stack=1;
						} else if(argn[1]==7) {
							if(chmod(argl[0],S_IRGRP)!=0) stack=1;
						} else if(argn[1]==8) {
							if(chmod(argl[0],S_IWGRP)!=0) stack=1;
						} else if(argn[1]==9) {
							if(chmod(argl[0],S_IXGRP)!=0) stack=1;
						} else if(argn[1]==10) {
							if(chmod(argl[0],S_IROTH)!=0) stack=1;
						} else if(argn[1]==11) {
							if(chmod(argl[0],S_IWOTH)!=0) stack=1;
						} else if(argn[1]==12) {
							if(chmod(argl[0],S_IXOTH)!=0) stack=1;
						} else puts("SYSCALL ERROR:15 ARG 2"), exit(0);
						break;					
					case 16:
						if(argl[0]==NULL) puts("SYSCALL ERROR:16 ARG 1"), exit(0);
						if(lchown(argl[0],argn[1],argn[2])!=0) stack=1;
						break;					
					case 17:
						break;					
					case 18:
						break;					
					case 19:
						if(argn[2]==1) {
							if((tmp=(int)lseek(var[argn[0]],argn[1],SEEK_SET))!=0) stack=1;
						} else if (argn[2]==2) {
							if((tmp=(int)lseek(var[argn[0]],argn[1],SEEK_CUR))!=0) stack=1;
						} else if (argn[3]==3) {
							if((tmp=(int)lseek(var[argn[0]],argn[1],SEEK_END))!=0) stack=1;
						} else puts("SYSCALL ERROR:19 ARG 3"), exit(0);
						break;					
					case 20:
						p++;
						a[p]='\0';
					        tmp=(int)getpid();
						for(q=0;q<tmp;q++) {
							a[p]++;
						}
						q=p;
						q++;
					        a[q]=tmp/255;	
						break;					
					case 21:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 21 ARG 1"), exit(0);
						if(argl[1]==NULL) puts("SYSCALL ERROR: 21 ARG 2"), exit(0);
						if(argl[2]==NULL) puts("SYSCALL ERROR: 21 ARG 3"), exit(0);
						if(argn[3]!=1 && argn[3]!=2 && argn[3]!=4 && argn[3]!=8 && argn[3]!=16 && argn[3]!=32)
							puts("SYSCALL ERROR: 21 ARG 4"), exit(0);
						else if(mount(argl[0],argl[1],argl[2],argn[3],NULL)!=0) stack=1;
						break;
					case 22:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 22 ARG 1"), exit(0);
						if(umount(argl[0])!=0) stack=1;
						break;					
					case 23:
						if(setuid(argn[0])!=0) stack=1;
						break;					
					case 24:
					        tmp=getuid();
       						for(q=0;q<tmp;q++) {
							a[p]++;
						}
						q=p;
						q++;
					        a[q]=tmp/255;	
						break;					
					case 25:
						break;					
					case 26:
						break;					
					case 27:
						if((tmp=alarm((unsigned)argn[0]))!=0) stack=1;
						q=p;
						q++;
						a[q]=tmp/2;
						break;					
					case 28:
						break;					
					case 29:
						pause;	
						break;					
					case 30:
						break;					
					case 31:
						break;					
					case 32:
						break;					
					case 33:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 33 ARG 1"), exit(0);
					        if(access(argl[0],argn[1])!=0) stack=1;
                                                break;
					case 34:
						if(nice(argn[0])!=0) stack=1;
						break;					
					case 35:	
						break;					
					case 36:
						sync;
						break;					
					case 37:
					        if(kill(argn[0], argn[1])!=0) stack=1;

						break;					
					case 38:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 38 ARG 1"), exit(0);
						if(argl[1]==NULL) puts("SYSCALL ERROR: 38 ARG 2"), exit(0);
						if(rename(argl[0],argl[1])!=0) stack=1;
						break;					
					case 39:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 39 ARG 1"), exit(0);
					        if(mkdir(argl[0],argn[1])!=0) stack=1;
						break;					
					case 40:
						if(argl[0]==NULL) puts("SYSCALL ERROR: 40 ARG 1"), exit(0);
					        if(rmdir(argl[0])!=0) stack=1;
						break;					
					case 41:
						if(var[argn[0]]==0) puts("SYSCALL ERROR: 41"), exit(0);
						if((var[argn[0]++]=dup(var[argn[0]]))==-1) stack=1;
						break;					
					case 42:
						break;					
					case 43:
						break;					
					case 44:	
						break;					
					case 45:
						break;					
					case 46:
						if(setgid(argn[0])!=0) stack=1;
						break;					
					case 47:
					        tmp=getgid();
       						for(q=0;q<tmp;q++) {
							a[p]++;
						}
						q=p;
						q++;
					        a[q]=tmp/255;	
						break;					
					case 48:
						break;					
					case 49:
						break;					
					case 50:
						break;					
					case 51:
					        if(argl[0]==NULL) puts("SYSCALL ERROR:51 ARG 1"), exit(0);
					        if(acct(argl[0])!=0) stack=1;
						break;					
					case 52:
						break;
					case 53:
						break;
					case 54:
						break;					
					case 55:
						if(var[argn[0]]==0) puts("SYSCALL ERROR:55"), exit(0);
					        if(fcntl(var[argn[0]],argn[1])!=0) stack=1;
						break;					
					case 56:
						break;					
					case 57:
					        if(setpgid(argn[0],argn[1])!=0) stack=1;
						break;					
					case 58:
						break;					
					case 59:
						break;					
					case 60:
						if((a[p++]=umask(argn[0]))!=0) stack=1;
						break;					
					case 61:
					        if(argl[0]==NULL) puts("SYSCALL ERROR:61 ARG 1"), exit(0);
					       	if(chroot(argl[0])!=0) stack=1;
						break;					
					case 62:
						break;					
					case 63:
						if(var[argn[0]]==0) puts("SYSCALL ERROR:63"), exit(0);
					        if(dup2(var[argn[0]],var[argn[1]])!=0) stack=1;
						break;					
					case 64:
						p++;
						a[p]='\0';
					        tmp=(int)getppid();
						for(q=0;q<tmp;q++) {
							a[p]++;
						}
						q=p;
						q++;
					        a[q]=tmp/255;	
						break;					
					case 65:
					        tmp=(int)getpgrp();
						for(q=0;q<tmp;q++) {
							a[p]++;
						}
						q=p;
						q++;
					        a[q]=tmp/255;	
						break;					
					case 66:
					        tmp=(int)setsid();
						for(q=0;q<tmp;q++) {
							a[p]++;
						}
						q=p;
						q++;
					        a[q]=tmp/255;	
					
						break;					
					case 67:
						break;					
					case 68:
						break;					
					case 69:
						break;					
					case 70:
						if(setreuid(argn[0],argn[1])!=0) stack=1;
						break;					
					case 71:
						if(setregid(argn[0],argn[1])!=0) stack=1;					
						break;					
					case 72:
						break;					
					case 73:
						break;					
					case 74:
						if(argl[0]==NULL) puts("SYSCALL ERROR:74 ARG 1"), exit(0);
					        if(sethostname(argl[0],argn[1])!=0) stack=1;

						break;					
					case 75:
						break;					
					case 76:
						break;					
					case 77:
						break;					
					case 78:
						break;					
					case 79:
						break;					
					case 80:	
						break;					
					case 81:
						break;					
					case 82:
						break;					
					case 83:
					        if(argl[0]==NULL) puts("SYSCALL ERROR:83 ARG 1"), exit(0);
					        if(argl[1]==NULL) puts("SYSCALL ERROR:83 ARG 1"), exit(0);
					        if(symlink(argl[0],argl[1])!=0) stack=1;
						break;					
					case 84:
						break;					
					case 85:
					        if(argl[0]==NULL) puts("SYSCALL ERROR:85 ARG 1"), exit(0);
					        if(readlink(argl[0],argl[1],argn[2])!=0) stack=1;
						break;					
					case 86:
					        if(argl[0]==NULL) puts("SYSCALL ERROR:86 ARG 1"), exit(0);
					        if(uselib(argl[0])!=0) stack=1;
						break;					
					case 87:
						if(argl[0]==NULL) puts("SYSCALL ERROR:87 ARG 1"), exit(0);
					        if(swapon(argl[0],argn[1])!=0) stack=1;
						break;					
					case 88:
						if(reboot(argn[0])!=0) stack=1;
						break;					
					case 89:	
						break;					
					case 90:
						break;					
					case 91:
						break;					
					case 92:
						if(argl[0]==NULL) puts("SYSCALL ERROR:92 ARG 1"), exit(0);
					        if(truncate(argl[0],argn[1])!=0) stack=1;
						break;					
					case 93:
					        if(ftruncate(var[argn[0]],argn[1])!=0) stack=1;
						break;					
					case 94:
						if(argl[0]==NULL) puts("SYSCALL ERROR:94 ARG 1"), exit(0);
						if(argn[1]==1) {
							if(chmod(argl[0],S_ISUID)!=0) stack=1;
						} else if(argn[1]==2) {
							if(chmod(argl[0],S_ISGID)!=0) stack=1;
						} else if(argn[1]==3) {
							if(chmod(argl[0],S_ISVTX)!=0) stack=1;
						} else if(argn[1]==4) {
							if(chmod(argl[0],S_IRUSR)!=0) stack=1;
						} else if(argn[1]==5) {
							if(chmod(argl[0],S_IWUSR)!=0) stack=1;
						} else if(argn[1]==6) {
							if(chmod(argl[0],S_IXUSR)!=0) stack=1;
						} else if(argn[1]==7) {
							if(chmod(argl[0],S_IRGRP)!=0) stack=1;
						} else if(argn[1]==8) {
							if(chmod(argl[0],S_IWGRP)!=0) stack=1;
						} else if(argn[1]==9) {
							if(chmod(argl[0],S_IXGRP)!=0) stack=1;
						} else if(argn[1]==10) {
							if(chmod(argl[0],S_IROTH)!=0) stack=1;
						} else if(argn[1]==11) {
							if(chmod(argl[0],S_IWOTH)!=0) stack=1;
						} else if(argn[1]==12) {
							if(chmod(argl[0],S_IXOTH)!=0) stack=1;
						} else puts("SYSCALL ERROR:94 ARG 2"), exit(0);
						break;
					case 95:
						if(fchown(var[argn[0]],argn[1],argn[2])!=0) stack=1;
						break;					
					case 96:
						break;					
					case 97:
						if(getpriority(argn[0],argn[1])!=0) stack=1;
						break;					
					case 98:
						if(setpriority(argn[0],argn[1],argn[2])!=0) stack=1;
						break;					
					case 99:
						break;					
					case 100:
						break;
					case 101:
						break;
					case 102:
						if(socketcall(argn[0],argn[1])!=0) stack=1;
						break;					
					case 103:
						if(syslog(argn[0],argl[1],argn[2])!=0);
						break;					
					case 104:
						break;					
					case 105:
						break;					
					case 106:
						break;					
					case 107:
						break;					
					case 108:
						break;					
					case 109:
						break;					
					case 110:
					        if(iopl(argn[0])!=0) stack=1;
						break;					
					case 111:
					        if(vhangup()!=0) stack=1;
						break;					
					case 112:
					        if(idle()!=0) stack=1;
						break;					
					case 113:
						break;					
					case 114:
						break;					
					case 115:
						if(argl[0]==NULL) puts("SYSCALL ERROR:115 ARG 1"), exit(0);
					        if(swapoff(argl[0])!=0) stack=1;
						break;					
					case 116:
						break;					
					case 117:
						break;					
					case 118:
					        if(fsync(var[argn[0]])!=0) stack=1;
						break;					
					case 119:
						break;					
					case 120:
						break;					
					case 121:
						break;					
					case 122:
						break;					
					case 123:	
						break;					
					case 124:
						break;					
					case 125:
						break;					
					case 126:
						break;					
					case 127:
						break;					
					case 128:
						break;					
					case 129:
						if(argl[0]==NULL) puts("SYSCALL ERROR:129 ARG 1"), exit(0);
						if(delete_module(argl[0])!=0) stack=1;
						break;					
					case 130:
						break;					
					case 131:
						break;					
					case 132:
						break;					
					case 133:
					        if(fchdir(var[argn[0]])!=0) stack=1;
						break;					
					case 134:
						break;					
					case 135:
						if(argl[1]==NULL) puts("SYSCALL ERROR:135 ARG 2"), exit(0);
						if(argn[0]<4) if(sysfs(argn[0],argl[1])!=0) stack=1;
						else puts("SYSCALL ERROR:135 ARG 1"), exit(0);
						break;					
					case 136:
						break;					
					case 137:
						break;					
					case 138:
					        if(setfsuid(argn[0])!=0) stack=1;
						break;					
					case 139:
					        if(setfsgid(argn[0])!=0) stack=1;					
						break;					
					case 140:
						break;					
					case 141:	
						break;					
					case 142:
						break;					
					case 143:
						break;					
					case 144:	
						break;					
					case 145:
						break;					
					case 146:
						break;					
					case 147:
						q=p;
						q++;
					        if(a[q]=getsid(argn[0])!=0) stack=1;
						break;					
					case 148:
						break;					
					case 149:
						break;					
					case 150:
						break;					
					case 151:
						if(argn[0]==1) {
						        if(mlockall(MCL_CURRENT)!=0);
						} else if(argn[0]==2) {
							if(mlockall(MCL_FUTURE)!=0);
						} else puts("SYSCALL ERROR:151 ARG 1"), exit(0);
						break;					
					case 152:
					        if(mlockall(argn[0])!=0) stack=1;
						break;
					case 153:
						if(munlockall()) stack=1;
						break;
					case 154:
						break;					
					case 155:
						break;					
					case 156:
						break;					
					case 157:
						break;					
					case 158:
						break;					
					case 159:
						break;					
					case 160:
						break;					
					case 161:
						break;					
					case 162:
						break;					
					case 163:
						break;					
					case 164:
						if(setresuid(argn[0],argn[1],argn[2])!=0) stack=1;
						break;					
					case 165:
						if(getresuid(argn[0],argn[1],argn[2])!=0) stack=1;
						break;					
					case 166:
						break;					
					case 167:
						break;					
					case 168:
						break;					
					case 169:
						break;					
					case 170:
						if(setresgid(argn[0],argn[1],argn[2])!=0) stack=1;
						break;					
					case 171:
						if(getresgid(argn[0],argn[1],argn[2])!=0) stack=1;
						break;					
					case 172:
						break;					
					case 173:
						break;					
					case 174:
						break;					
					case 175:
						break;					
					case 176:
						break;					
					case 177:
						break;					
					case 178:
						break;					
					case 179:
						break;					
					case 180:
						if(argl[1]==NULL) puts("SYSCALL ERROR:180 ARG 2"), exit(0);
						if((tmp=(int)pread(var[argn[0]],argl[1],argn[2],argn[3]))==-1) stack=1;
						else {
	   						for(q=0;q<tmp;q++) {
								a[p]++;
							}
							q=p;
							q++;
						        a[q]=tmp/255;
						}
						break;					
					case 181:
						if(argl[1]==NULL) puts("SYSCALL ERROR:181 ARG 2"), exit(0);
						if((tmp=(int)pwrite(var[argn[0]],argl[1],argn[2],argn[3]))==-1) stack=1;
						else {
	   						for(q=0;q<tmp;q++) {
								a[p]++;
							}
							q=p;
							q++;
						        a[q]=tmp/255;
						}
						break;					
					
						break;					
					case 182:
						if(argl[0]==NULL) puts("SYSCALL ERROR:181 ARG 2"), exit(0);
						if(chown(argl[0],argn[1],argn[2])!=0) stack=1;
						break;					
					case 183:
						break;					
					case 184:
						break;					
					case 185:
						break;					
					case 186:
						break;					
					case 187:
						break;					
					case 188:
						break;					
					case 189:	
						break;					
					case 190:
						vfork();
						break;					
					case 191:
						break;					
					case 192:
						break;					
					case 193:
						break;					
					case 194:
						break;					
					case 195:
						break;					
					case 196:
						break;					
					case 197:
						break;					
					default:
						puts("SYSCALL ERROR"), exit(0);
				}
				break;
			default: o=0;
		}			
		if(p<0 || p>100)
			puts("RANGE ERROR"), exit(0);
		if(t<0 || t>100)
			puts("RANGE ERROR"), exit(0);
	}
	r--;
}

int main(int argc,char *argv[])
{
	FILE *z;

	q=argc;

	if((z=fopen(argv[1],"r"))) {
		while((b=getc(z))>0)
			*s++=b;
		*s=0;
		interpret(f);
	} else
		puts("FILE ERROR"), exit(0);
	return 0;
}
